<?xml version="1.0" encoding="UTF-8"?>

<!DOCTYPE system [
 <!ENTITY IND "2">
 <!ENTITY U "propulsion/inlet[&IND;]">
 <!ENTITY HS "systems/hydr/hs[2]">
 <!ENTITY HSB "systems/hydr/hs[3]">
]>

<system name="Tu-144D inlet">
 <!-- CУЗ9-1 (НК-144А), СУЗ-10 (РД-36-51А) -->

 <!--
  Regimes: [Bliznyuk p. 129]
  Test: [Flight Manual 4.1.4.9]
  Behaviour: [Flight Manual 4.3.4.1]
 -->

 <!-- FIXME Subsonic position at M1.1 from emergency power [ZLA p. 392]. -->


 <!-- -1: backup, 0: manual, 1: main -->
 <property value="1">&U;/panel/switch/auto</property>
 <!-- -1: backup, 0: off, 1: main -->
 <property value="-1">&U;/panel/switch/manual</property>
 <property value="1">&U;/panel/switch/spill-auto</property>
 <property>&U;/panel/pot/ramp-norm</property>
 <property>&U;/panel/pot/spill-norm</property>

 <property>&U;/panel-groundtest/switch/imitate-M1.25</property>
 <property>&U;/panel-groundtest/switch/imitate-M1.9</property>
 <property>&U;/panel-groundtest/switch/SIOD-block</property>




 <channel name="Status" execrate="4">

  <switch name="&U;/status/channel">
   <!-- -1: backup, 0: off, 1: main -->
   <default value="&U;/panel/switch/manual"/>
   <test value="0">
    systems/elec/DC27/U-ok EQ 0
   </test>
   <test logic="AND" value="2">
    &U;/panel/switch/auto NE 0
    &HS;/P-kgf_cm2 LT 50.0
    &HSB;/P-kgf_cm2 GT 190.0
   </test>
   <test value="&U;/panel/switch/auto">
    &U;/panel/switch/auto NE 0
   </test>
  </switch>

  <switch name="&U;/func/M">
   <default value="velocities/mach"/>
   <test value="1.9">
    &U;/panel-groundtest/switch/imitate-M1.9 NE 0
   </test>
   <test value="1.25">
    &U;/panel-groundtest/switch/imitate-M1.25 NE 0
   </test>
  </switch>

 </channel>


 <channel name="Ramp" execrate="4">

  <fcs_function name="&U;/ramp/optimal-pos-norm">
   <function>
    <table>
     <independentVar lookup="row">velocities/mach</independentVar>
     <independentVar lookup="column">&U;/n2</independentVar>
     <tableData>
		0.0	50.0	90.0
	1.2	0.0	0.0	0.0
	1.25	1.0	0.5	0.0
	1.9	1.0	1.0	0.5
	2.1	1.0	1.0	0.55
	2.3	1.0	1.0	0.6
     </tableData>
    </table>
   </function>
  </fcs_function>

  <fcs_function name="&U;/ramp/command-auto-norm">
   <function>
    <table>
     <independentVar lookup="row">&U;/func/M</independentVar>
     <independentVar lookup="column">&U;/n2</independentVar>
     <tableData>
		0.0	50.0	90.0
	1.2	0.0	0.0	0.0
	1.25	1.0	0.5	0.0
	1.9	1.0	1.0	0.5
	2.1	1.0	1.0	0.55
	2.3	1.0	1.0	0.6
     </tableData>
    </table>
   </function>
  </fcs_function>

  <switch name="&U;/ramp/command-norm">
   <default value="&U;/ramp/command-auto-norm"/>
   <test logic="AND" value="&U;/panel/pot/ramp-norm">
    &U;/panel/switch/auto EQ 0
   </test>
  </switch>

  <actuator name="&U;/ramp/pos-norm">
   <input>&U;/ramp/command-norm</input>
   <rate_limit>&U;/hydr/P-norm</rate_limit>
  </actuator>

  <washout_filter name="&U;/ramp/func/pos-dot-norm_sec">
   <input>&U;/ramp/pos-norm</input>
   <c1>simulation/init-washout-c1</c1>
  </washout_filter>

 </channel>


 <channel name="Spill" execrate="4">

  <fcs_function name="&U;/spill/optimal-pos-norm">
   <function>
    <table>
     <independentVar lookup="row">velocities/mach</independentVar>
     <independentVar lookup="column">&U;/n2</independentVar>
     <tableData>
		0.0	58.5	67.0	80.0
	1.2	0.0	0.0	0.0	0.0
	1.25	1.0	0.0	0.0	0.0
	1.8	1.0	0.0	0.0	0.0
	1.85	1.0	1.0	0.0	0.0
	1.9	1.0	1.0	1.0	0.0
     </tableData>
    </table>
   </function>
  </fcs_function>

  <switch name="&U;/spill/command-norm">
   <default value="&U;/spill/command-auto-norm"/>
   <test logic="AND" value="&U;/panel/pot/spill-norm">
    &U;/panel/switch/spill-auto EQ 0
   </test>
  </switch>

  <fcs_function name="&U;/spill/command-auto-norm">
   <function>
    <table>
     <independentVar lookup="row">&U;/func/M</independentVar>
     <independentVar lookup="column">&U;/n2</independentVar>
     <tableData>
		0.0	58.5	67.0	80.0
	1.2	0.0	0.0	0.0	0.0
	1.25	1.0	0.0	0.0	0.0
	1.8	1.0	0.0	0.0	0.0
	1.85	1.0	1.0	0.0	0.0
	1.9	1.0	1.0	1.0	0.0
     </tableData>
    </table>
   </function>
  </fcs_function>

  <actuator name="&U;/spill/pos-norm">
   <input>&U;/spill/command-norm</input>
   <rate_limit>&U;/hydr/P-norm</rate_limit>
  </actuator>

  <washout_filter name="&U;/spill/func/pos-dot-norm_sec">
   <input>&U;/spill/pos-norm</input>
   <c1>simulation/init-washout-c1</c1>
  </washout_filter>

 </channel>


 <channel name="Flaps" execrate="4">

  <!-- Unpowered, damped. Close at 700..900 km/h. [Bliznyuk p. 126] -->

  <fcs_function name="&U;/flap/pos-norm">
   <function>
    <table>
     <independentVar>&U;/P-diff-atm</independentVar>
     <tableData>
        -0.1    1.0
        0.0     0.0
     </tableData>
    </table>
   </function>
  </fcs_function>

 </channel>


 <channel name="Performance" execrate="4">

  <fcs_function name="&U;/efficiency-norm">
   <output>propulsion/engine[&IND;]/inlet-efficiency-norm</output>
   <function>
    <difference>
     <v>1.0</v>
     <product>
      <v>0.6</v>
      <min>
       <v>1.0</v>
       <sum>
        <abs>
         <difference>
          <p>&U;/ramp/optimal-pos-norm</p>
          <p>&U;/ramp/pos-norm</p>
         </difference>
        </abs>
        <abs>
         <difference>
          <p>&U;/spill/optimal-pos-norm</p>
          <p>&U;/spill/pos-norm</p>
         </difference>
        </abs>
       </sum>
      </min>
     </product>
    </difference>
   </function>
  </fcs_function>

  <pure_gain name="&U;/T-diff-K">
   <input>propulsion/tat-diff-K</input>
   <gain>&U;/efficiency-norm</gain>
  </pure_gain>

  <summer name="&U;/T-degC_">
   <input>atmosphere/T-degC</input>
   <input>&U;/T-diff-K</input>
  </summer>

  <switch name="&U;/T-degC">
   <output>propulsion/engine[&IND;]/inlet-air-temp-degC</output>
   <default value="&U;/T-degC_"/>
   <test value="propulsion/hot-air-unit-temp-degC">
    propulsion/hot-air-unit NE 0
   </test>
  </switch>

  <summer name="&U;/T-K">
   <output>propulsion/engine[&IND;]/inlet-air-temp-K</output>
   <input>&U;/T-degC</input>
   <bias>273.15</bias>
  </summer>

  <fcs_function name="&U;/P-diff-atm">
   <function>
    <sum>
     <table>
      <!-- Estimate from [Bliznyuk p. 112] -->
      <independentVar>&U;/n2</independentVar>
      <tableData>
	0.0	0.0
	90.0	-0.1
      </tableData>
     </table>
     <product>
      <p>&U;/efficiency-norm</p>
      <p>aero/qimpact-atm</p>
      <table>
       <!-- [Bliznyuk p. 112] Pressure recovery In TsAGI definition (\sigma_{st}) -->
       <independentVar lookup="row">velocities/mach</independentVar>
       <tableData>
	0.0	0.9
	0.7	0.97
	0.85	0.97
	1.2	0.97
	1.8	0.94
	2.0	0.92
	2.2	0.9
       </tableData>
      </table>
     </product>
    </sum>
   </function>
  </fcs_function>

 </channel>


 <channel name="Electric consumers" execrate="4">

  <pure_gain name="&U;/elec/DC27-A">
   <input>systems/elec/DC27/U-V</input>
   <!-- 100 W -->
   <gain>0.137</gain>
  </pure_gain>

 </channel>


 <channel name="Hydraulic consumers" execrate="4">

  <switch name="&U;/hydr/P-kgf_cm2">
   <default value="0"/>
   <test value="&HS;/P-kgf_cm2">
    &U;/status/channel EQ 1
   </test>
   <test value="&HSB;/P-kgf_cm2">
    &U;/status/channel EQ -1
   </test>
  </switch>

  <pure_gain name="&U;/hydr/P-norm">
   <input>&U;/hydr/P-kgf_cm2</input>
   <!-- = 1 / 100 -->
   <gain>0.01</gain>
   <clipto>
    <min>0.0</min>
    <max>1.0</max>
   </clipto>
  </pure_gain>

  <fcs_function name="&U;/hydr/func/flow-l_min">
   <function>
    <product>
     <sum>
      <p>&U;/ramp/func/pos-dot-norm_sec</p>
      <p>&U;/spill/func/pos-dot-norm_sec</p>
     </sum>
     <!-- = 1 * 60 -->
     <v>60.0</v>
    </product>
   </function>
  </fcs_function>

  <switch name="&U;/hydr/flow-l_min[0]">
   <default value="0.0"/>
   <test value="&U;/hydr/func/flow-l_min">
    &U;/status/channel EQ 1
   </test>
  </switch>

  <switch name="&U;/hydr/flow-l_min[1]">
   <default value="0.0"/>
   <test value="&U;/hydr/func/flow-l_min">
    &U;/status/channel EQ -1
   </test>
  </switch>

 </channel>


 <channel name="Gauges" execrate="4">

  <switch name="&U;/panel/gauge/P-diff-atm">
   <default value="0"/>
   <test value="&U;/P-diff-atm">
    systems/elec/DC27/U-ok NE 0
   </test>
  </switch>

  <switch name="&U;/panel/gauge/ramp-pos-norm">
   <default value="0"/>
   <test value="&U;/ramp/pos-norm">
    systems/elec/DC27/U-ok NE 0
   </test>
  </switch>

  <switch name="&U;/panel/gauge/spill-pos-norm">
   <default value="0"/>
   <test value="&U;/spill/pos-norm">
    systems/elec/DC27/U-ok NE 0
   </test>
  </switch>

 </channel>


 <channel name="Lights" execrate="4">

  <switch name="&U;/panel/light/main">
   <default value="0"/>
   <test value="systems/elec/DC27/U-ok">
    propulsion/engine[0]/panel/button/test-lights NE 0
   </test>
   <test logic="AND" value="systems/elec/DC27/U-ok">
    &U;/status/channel EQ 1
    &U;/ramp/pos-norm GT 0.01
    &U;/panel/switch/auto NE 0
   </test>
  </switch>

  <switch name="&U;/panel/light/backup">
   <default value="0"/>
   <test value="systems/elec/DC27/U-ok">
    propulsion/engine[0]/panel/button/test-lights NE 0
   </test>
   <test logic="AND" value="systems/elec/DC27/U-ok">
    &U;/status/channel EQ -1
    &U;/ramp/pos-norm GT 0.01
    &U;/panel/switch/auto NE 0
   </test>
  </switch>

  <switch name="&U;/panel/light/ramp-manual">
   <default value="0"/>
   <test value="systems/elec/DC27/U-ok">
    propulsion/engine[0]/panel/button/test-lights NE 0
   </test>
   <test logic="AND" value="systems/elec/DC27/U-ok">
    &U;/status/channel NE 0
    &U;/panel/switch/auto EQ 0
   </test>
  </switch>

  <switch name="&U;/panel/light/spill-auto">
   <default value="0"/>
   <test value="systems/elec/DC27/U-ok">
    propulsion/engine[0]/panel/button/test-lights NE 0
   </test>
   <test logic="AND" value="systems/elec/DC27/U-ok">
    &U;/status/channel NE 0
    &U;/spill/command-norm GT 0.01
    &U;/panel/switch/spill-auto NE 0
   </test>
  </switch>

  <switch name="&U;/panel/light/spill-manual">
   <default value="0"/>
   <test value="systems/elec/DC27/U-ok">
    propulsion/engine[0]/panel/button/test-lights NE 0
   </test>
   <test logic="AND" value="systems/elec/DC27/U-ok">
    &U;/status/channel NE 0
    &U;/panel/switch/spill-auto EQ 0
   </test>
  </switch>

  <!-- 2 separate lights for ramp and spill. -->
  <switch name="&U;/panel/light/inop">
   <default value="0"/>
   <test logic="OR" value="systems/elec/DC27/U-ok">
    &U;/status/channel EQ 0
    &U;/hydr/P-norm LT 0.5
    propulsion/engine[0]/panel/button/test-lights NE 0
   </test>
  </switch>

 </channel>


</system>
